<!DOCTYPE html>
<html lang="en">
<head>
<title>Trabalho Redes II</title>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<style>
* {
    box-sizing: border-box;
}

body {
    font-family: Arial, Helvetica, sans-serif;
}

/* Style the header */
header {
    background-color: #666;
    padding: 30px;
    text-align: center;
    font-size: 35px;
    color: white;
}

/* Create two columns/boxes that floats next to each other */
nav {
    float: left;
    width: 10%;
    background: #ccc;
    padding: 20px;
}

/* Style the list inside the menu */
nav ul {
    list-style-type: none;
    padding: 0;
}

article {
    float: left;
    padding: 20px;
    width: 90%;
    background-color: #f1f1f1;
}

/* Clear floats after the columns */
section:after {
    content: "";
    display: table;
    clear: both;
}

/* Style the footer */
footer {
    background-color: #777;
    padding: 10px;
    text-align: center;
    color: white;
}

/* Responsive layout - makes the two columns/boxes stack on top of each other instead of next to each other, on small screens */
@media (max-width: 600px) {
    nav, article {
        width: 100%;
        height: auto;
    }
}
</style>
</head>
<body>
<header>
  <h2>Servidor de Proxy SQUID</h2>
</header>

<section>
  <nav>
    <ul>
      <li><a href="index.html">Homepage</a></li>
    </ul>
  </nav>
  
  <article>
    <h1>Trabalho II - Redes de Computadores II</h1>
    <h1>Servidor de proxy com SQUID</h1>
	<p>
	O Squid é um servidor de Proxy que trabalha como saída principal da rede. Com ele, podemos trazer mais segurança em nossa rede, criando políticas de acesso, autenticação, entre outros, em uma única máquina.
	O Squid trabalha com os principais protocolos da Internet, alguns deles são: HTTP, HTTPS, FTP.<p>
	<p>O Squid é um Software Livre licenciado pela licença GPL e sua utilização pode nos trazer várias vantagens, como:<br>
    <b>Autenticação;</b><br>
    <b>Controle de acesso;</b><br>
    <b>Cache;</b><br>
    <b>Controle centralizado;</b><br>
    <b>Registros de acesso, etc.</b><p> 
	<p>Ele também atua como Proxy transparente evitando que usuários "espertinhos" possam burlar o controle de acesso.<br>
Este tutorial é voltado à distribuições baseadas no Debian. Ele utiliza o Vagrant para provisionamento
de maquinas virtuais.<p>
<p>O seguinte esquema, demonstra onde estão os arquivos necessários para a instalação do serviço:<p>
<b>VagrantFile>>modules</b><br>
<p>As seguintes pastas foram criadas dentro da pasta <b>modules:</b><p>
<b>lynx, squid, arquivos</b><br>
<p>Dentro da pasta lynx foi criado uma pasta com os respectivos códigos:<p>
<b>lynx>>manifests>>init.pp</b><br>
<p>Segue abaixo o código do arquivo <b>'init.pp'</b>.<p>
<textarea rows="8" cols="80" readonly>class lynx {

  package { "lynx":   # deve conter o nome do pacote a ser instalado
    ensure  => present,
    require => Class["system-update"],
  }
}</textarea>

<p>Dentro da pasta squid, foi criado uma pasta com os respectivos códigos:<p>
<b>squid>>manifests>>init.pp</b><br>
<p>Segue abaixo o código do arquivo <b>'init.pp'</b>.<p>
<textarea rows="13" cols="80" readonly>class squid {

  package { "squid":   # deve conter o nome do pacote a ser instalado
    ensure  => present,
    require => Class["system-update"],
  }

  service { "squid3":    # nome do serviço 
    ensure  => "running",
    require => Package["squid"],
  }

}</textarea>

<p>Dentro da pasta arquivos, foram criados duas pastas com os respectivos códigos:<p>
<b>arquivos>>files</b><br>
<b>arquivos>>manifests>>init.pp</b><br>
<p>Segue abaixo o código do arquivo <b>'init.pp'</b>.<p>
<textarea rows="20" cols="80" readonly>class arquivos {

# Realiza a cópia dos arquivos para o diretório padrão do nginx
#'require' utilizado para não ocorrer erros nas dependências dos arquivos

#copia o arquivo index.html para a pasta padrão do nginx
file {'/usr/share/nginx/www/index.html':
     ensure => file,
     require => Package["nginx"],
     owner  => 'root',
     group  => 'root',
     mode   => '0755',
     source => 'puppet:///modules/arquivos/index.html',
   }

file {'/etc/squid3/formato_arquivo.txt':
     ensure => file,
     require => Package["squid"],
     owner  => 'root',
     group  => 'root',
     mode   => '0644',
     source => 'puppet:///modules/arquivos/formato_arquivo.txt',
   }
file {'/etc/squid3/ips_liberados.txt':
     ensure => file,
     require => Package["squid"],
     owner  => 'root',
     group  => 'root',
     mode   => '0644',
     source => 'puppet:///modules/arquivos/ips_liberados.txt',
   }
file {'/etc/squid3/palavras_bloqueadas.txt':
     ensure => file,
     require => Package["squid"],
     owner  => 'root',
     group  => 'root',
     mode   => '0644',
     source => 'puppet:///modules/arquivos/palavras_bloqueadas.txt',
   }
file {'/etc/squid3/redes_sociais.txt':
     ensure => file,
     require => Package["squid"],
     owner  => 'root',
     group  => 'root',
     mode   => '0644',
     source => 'puppet:///modules/arquivos/redes_sociais.txt',
   }
file {'/etc/squid3/sites_bloqueados.txt':
     ensure => file,
     require => Package["squid"],
     owner  => 'root',
     group  => 'root',
     mode   => '0644',
     source => 'puppet:///modules/arquivos/sites_bloqueados.txt',
   }
file {'/etc/squid3/squid.conf':
     ensure => file,
     require => Package["squid"],
     owner  => 'root',
     group  => 'root',
     mode   => '0644',
     source => 'puppet:///modules/arquivos/squid.conf',
   }
}</textarea>

<p>Este arquivo manifest, possui o código necessário para a cópia dos arquivos para dentro da máquina virtual.<p>
<p>Dentro da pasta files, foram criados os respectivos arquivos:<p>
<b>formato_arquivo.txt<br> index.html<br> ips_liberados.txt<br> palavras_bloqueadas.txt<br> redes_sociais.txt<br> sites_bloqueados.txt<br> sites_porno.txt <br> squid.conf</b><br>

<p>Após a criação destes arquivos, iremos mostrar o código de dois arquivos, squid.conf e sites-bloqueados.txt:<p>
<p>Segue abaixo o código do arquivo <b>'squid.conf'</b>.<p>

<textarea rows="20" cols="150" readonly># Define em qual porta o Squid vai atuar, a porta default é a 3128, mas podemos definir qualquer outra porta. 
http_port 3128

#Define o nome do servidor, lembre-se de substituir o "KORZOS" pelo nome do seu servidor. 
visible_hostname GRUPO1

# Define o caminho das páginas de erro do squid.
error_directory /usr/share/squid/errors/Portuguese

# Esta opção manda o Squid buscar os dados diretamente na origem, ela é referente ao conteúdo dinâmico, se a URL conter algum padrão aqui especificado ela irá direto a origem buscar o conteúdo.
hierarchy_stoplist CGI-bin ?

# Define o e-mail que vai aparecer na página de erro do Squid, assim o usuário terá mais informações para interagir com o responsável.
cache_mgr admin@seu_dominio.com.br

## Esta ACL é responsável por não armazenar conteúdo CGI em cache.
acl QUERY urlpath_regex cgi-bin ?
no_cache deny QUERY

# Define a quantidade de memória RAM reservada para o uso do Squid.
cache_mem 64 MB
# Esta linha é responsável por limitar o tamanho dos arquivos que serão armazenados no cache da memória RAM.
maximum_object_size_in_memory 64 KB
# Aqui definimos o tamanho máximo e mínimo respectivamente dos arquivos que serão armazenados no cache do HD.
maximum_object_size 512 MB
minimum_object_size 0 KB

# Com essas duas linhas podemos definir a porcentagem de atualização do cache, estamos dizendo que quando o cache chegar em 95% o Squid irá apagar os arquivos mais antigos até chegar a 90%.
cache_swap_low 90
cache_swap_high 95

# Nessa linha conseguimos definir o tamanho e alguns parâmetros do cache feito em HD, a linha é composta por quatro valores, o 1º define o caminho do cache (/var/spool/squid), o 2º o tamanho que será alocado 
#em MB para o cache (2Gb), o 3º a quantidade de diretórios criados para o cache (16) e o 4º é o numero de subdiretórios que serão criados. Se você possuir bastante espaço em disco e quiser armazenar os arquivos 
#por mais tempo, aumente a opção do tamanha do cache.
cache_dir ufs /var/spool/squid 2048 16 256
# Define onde serão armazenados os registros de log do Squid.
cache_access_log /var/log/squid/access.log

#Essas três linhas definem o intervalo de atualização do cache, ou seja, de quanto em quanto tempo o Squid irá aguardar antes de verificar se algum arquivo em cache foi alterado em seu 
#local original (um download ou uma pagina Web, por exemplo). 
refresh_pattern ^ftp: 15 20% 2280
refresh_pattern ^gopher: 15 0% 2280
refresh_pattern . 15 20% 2280

#Esta linha cria uma ACL, uma política de acesso com nome "all" contendo qualquer IP. 
acl all src 0.0.0.0/0.0.0.0
#Cria a ACL manager do tipo proto. 
acl manager proto cache_object
#Aqui criamos uma ACL de nome "localhost" contendo localhost. 
acl localhost src 127.0.0.1/255.255.255.255
#Cria a ACL contendo as portas que são utilizadas no protocolo HTTPS. 
acl SSL_ports port 443 563
#Cria a ACL contendo as portas de diversos protocolos conhecidos na Internet. 
acl Safe_ports port 21 80 443 563 70 210 280 488 59 777 901 1025-65535

#Cria a ACL manager do tipo method. 
acl purge method PURGE
#Cria a ACL CONNECT também do tipo method. 
acl CONNECT method CONNECT

#Libera a ACL manager e localhost. 
http_access allow manager localhost
#Bloqueia a ACL manager. 
http_access deny manager
#Libera a ACL purge e localhost 
http_access allow purge localhost
#Bloqueia a ACL purge.
http_access deny purge
#Esta linha se torna bastante interessante pelo uso da "!", pois ela bloqueia qualquer conexão que não contenha o conteúdo da ACL Safe_Ports. 
http_access deny !Safe_ports
#Bloqueia qualquer conexão que não esteja no conteúdo da ACL SSL_ports. 
http_access deny CONNECT !SSL_ports


#Cria a ACL rede_local contendo a faixa de endereço da rede local. 
acl rede_local src 192.168.0.0/24

#Cria a ACL palavras_bloqueadas contendo as palavras proibidas que estão no arquivo descrito. 
acl palavras_bloqueadas url_regex -i "/etc/squid/palavras_bloqueadas.txt "

#Cria a ACL sites_bloqueados contendo os sites proibidos que estão no arquivo descrito.
acl sites_bloqueados url_regex -i "/etc/squid/sites_bloqueados.txt "

#Cria a ACL redes_sociais contendo os sites de redes sociais que estão no arquivo descrito. 
acl redes_sociais url_regex -i "/etc/squid/redes_sociais.txt"

# Cria a ACL liberados contendo endereços de IP que estão no arquivo descrito. 
acl liberados src "/etc/squid/ips_liberados.txt "

#Cria a ACL porno contendo os sites pornôs que estão no arquivo descrito. 
acl porno url_regex -i "/etc/squid/sites_porno.txt "

#Cria a ACL formato_arquivo contendo os tipos de arquivos que serão bloqueados que estão no arquivo descrito. 
acl formato_arquivo url_regex -i "/etc/squid/formato_arquivo.txt"

#Cria a ACL horario_almoco do horário de meio dia há uma da tarde. 
acl horario_almoco time 12:00-13:00

#Liberação do acesso total para os IP’s que estiverem no arquivo que criamos anteriormente
http_access allow liberados

#Nestas linhas, permitimos que qualquer usuário acesse os sites de redes sociais que estiverem no arquivo que criamos dentro do horário de 12:00 as 13:00, após esse horário, o acesso é bloqueado. 
http_access allow redes_sociais  horario_almoco
http_access deny redes_sociais

#Bloqueia o acesso aos sites que estiverem no arquivo criado dentro da ACL 'sites_bloqueados'. 
http_access deny sites_bloqueados

#Bloqueia o acesso à palavras que estiverem no arquivo criado dentro da ACL 'palavras_bloqueadas'. 
http_access deny palavras_bloqueadas

#Bloqueia o acesso aos sites pornos que estiverem no arquivo criado dentro da ACL 'porno'. 
http_access deny porno

#Bloqueia o acesso a downloads que forem do tipo de arquivo contido no arquivo criado na ACL 'formato_arquivo'. 
http_access deny formato_arquivo

#Se o acesso não se encaixou em nenhuma das regras acima e for proveniente da rede interna, ele é liberado. 
http_access allow rede_local
#Libera a ACL redelocal. 
http_access allow localhost

#Bloqueia a ACL all 
http_access deny all </textarea>
<p>Note que as linha que começam com '#' são os comentarios da linha abaixo, em qual configuração estamos realizando a alteração.<p>
<p>Os controles de acesso realizados acima, são os seguintes:<br>
*Somente os usuarios da rede local podem acessar os sites externos, outros usuários estão bloqueados.<br>
*Alguns sites são bloquados.<br>
*Algumas palavras são bloqueadas.<br>
*Endereços de IP’s podem ser reservados, com acesso total na rede.<br>
*Controle de acesso a redes sociais é imposto.<br>
*Alguns formatos de arquivos são bloqueados.<p>
<p>Outras configurações são aplicadas conforme o comentario que o sucede, as quais podem serem analisadas com o arquivo para maiores informações.<p>

<p>Segue abaixo o código do arquivo <b>'sites_bloqueados.txt'</b>.<p>
<textarea rows="1" cols="40" readonly>www.google.</textarea>
<p>Com essa linha neste arquivo, estaremos bloqueando o acesso a esse site na rede. Note que colondo apenas o '.', estaremos bloqueando qualquer palavra após o ponto, podendo ser www.google.com.ar, etc..
<p>Realizado toda a configuração necessária, podemos provisionar a máquina virtual com o comando: <p>
<b>vagrant up</b>.<p>
<p>Pronto! O seu servido de proxy SQUID está funcionando e pronto para uso.</p>
<p>Os seguintes serviços foram provisionados na sua máquina virtual:<p>
<p><b>Lynx:</b> Para o teste se o servidor de proxy squid encontra-se em funcionamento.<p>
<p><b>Nginx:</b> Para o serviço de páginas. <p>
<p><b>Squid:</b> Servidor de proxy. <p>

<h1>Importante!</h1>
<p>Para nos certificarmos que o Squid esta funcionando, devemos utilizar um navegador por linhas de código que aceita uma configuração de proxy de maneira bem simples, que ja foi instalado, o Lynx. Com o comando abaixo, configuramos o lynx para utilizar o proxy da rede local:
<p>Esse navegador é utilizado no bash e devemos realizar a seguinte configuração:</p>
<b>export http_proxy=http://localhost:3128</b><br>
<p>Com essa linha, estamos passando a configuração do squid, que se encontra funcionando na rede local(localhost), e para acessarmos uma página, devemos faze-la da seguinte maneira:<p>
<p>Após isso, devemos reiniciar o serviço do squid, com o seguinte comando: <p>
<b>sudo service squid3 restart</b><br>
<b>lynx www.google.com.br</b><br>
<p>Se o site foi bloqueado, o seu servidor Squid está em funcionamento.<p>
<p>Abraços..<p>


<br><br><br><br>
    <h4>Integrantes do Grupo:</h4>
	<p>Gémerson Jonatã Rhoden</p>
	<p>Renan Schmitt de Oliveira</p>
  </article>
</section>

<footer>
  <p>Trabalho I - Rede de Computadores II</p>
  <p>Gémerson J. Rhoden, Renan S. de Oliveira</p>
</footer>

</body>
</html>
